package com.fahri.matlab.client;

import com.rabbitmq.client.ShutdownSignalException;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * @author admin
 */
public class MatlabClient extends javax.swing.JFrame {

    private static MatlabRPC matlabRpc;
    BufferedImage responseBufferedImage;
    private DefaultListModel listVariableModel;
    private DefaultListModel listCommandModel;
    private boolean isContainingVariable;
    private JFileChooser fileChooser;
    // Variables declaration - do not modify
    private javax.swing.JButton btnClear;
    private javax.swing.JButton btnExe;
    private javax.swing.JButton btnSaveImage;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JLabel lblDescVarName;
    private javax.swing.JLabel lblHost;
    private javax.swing.JLabel lblImage;
    private javax.swing.JLabel lblToken;
    private javax.swing.JList listCommand;
    private javax.swing.JList listVariable;
    private javax.swing.JMenu menuEdit;
    private javax.swing.JMenu menuFile;
    private javax.swing.JMenuItem menuitemConnectToJMSHost;
    private javax.swing.JMenuItem menuitemExit;
    private javax.swing.JPanel pnlImage;
    private javax.swing.JTextArea txtDescVarValue;
    private javax.swing.JTextField txtQuery;
    private javax.swing.JTextArea txtareaEditor;
    /**
     * Creates new form MatlabClient
     */
    public MatlabClient() {


        listVariableModel = new DefaultListModel();
        listCommandModel = new DefaultListModel();

        initComponents();

        lblToken.setText(matlabRpc.getToken());
        lblHost.setText(matlabRpc.getHostIp());

        fileChooser = new JFileChooser();

        listVariable.setModel(listVariableModel);
        listVariable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        listVariable.setSelectedIndex(0);
        listVariable.addMouseListener(new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent evt) {
                JList list = (JList) evt.getSource();
                if (evt.getClickCount() == 1) {
                    int index = list.locationToIndex(evt.getPoint());
                    lblDescVarName.setText(((Variable) listVariableModel.get(index)).getName());
                    txtDescVarValue.setText(((Variable) listVariableModel.get(index)).getValue());
                } else if (evt.getClickCount() == 2) {
                    int index = list.locationToIndex(evt.getPoint());
                    String oldQuery = txtQuery.getText();
                    txtQuery.setText(oldQuery + " " + ((Variable) listVariableModel.get(index)).getName());
                } else if (evt.getClickCount() == 3) {   // Triple-click
                    int index = list.locationToIndex(evt.getPoint());

                }
            }
        });

        listCommand.setModel(listCommandModel);
        listCommand.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        listCommand.setSelectedIndex(0);
        listCommand.addMouseListener(new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent evt) {
                JList list = (JList) evt.getSource();
                if (evt.getClickCount() == 2) {
                    int index = list.locationToIndex(evt.getPoint());
                    String command = (String) listCommandModel.get(index);
                    String oldQuery = txtQuery.getText();
                    txtQuery.setText(oldQuery + " " + command);
                }
            }
        });


        try {
            UIManager.setLookAndFeel(
                    UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            System.err.println("Couldn't use system look and feel.");
        }

    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                boolean onConnect = false;
                while (!onConnect) {
                    String ipAddress = JOptionPane.showInputDialog("Input IP address of Message Broker Host : ");
                    try {
                        matlabRpc = new MatlabRPC(ipAddress);
                        onConnect = true;
                    } catch (IOException ex) {
                        JOptionPane.showMessageDialog(null, "Unable to connect !");
                        onConnect = false;
                    }
                }
                new MatlabClient().setVisible(true);
            }
        });
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {

        pnlImage = new javax.swing.JPanel();
        lblImage = new javax.swing.JLabel();
        btnSaveImage = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        listVariable = new javax.swing.JList(listVariableModel);
        jScrollPane3 = new javax.swing.JScrollPane();
        txtDescVarValue = new javax.swing.JTextArea();
        lblDescVarName = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        lblToken = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        lblHost = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtareaEditor = new javax.swing.JTextArea();
        txtQuery = new javax.swing.JTextField();
        btnExe = new javax.swing.JButton();
        btnClear = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        listCommand = new javax.swing.JList();
        jMenuBar1 = new javax.swing.JMenuBar();
        menuFile = new javax.swing.JMenu();
        menuitemExit = new javax.swing.JMenuItem();
        menuEdit = new javax.swing.JMenu();
        menuitemConnectToJMSHost = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }

            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        pnlImage.setBackground(new java.awt.Color(255, 255, 255));
        pnlImage.setBorder(javax.swing.BorderFactory.createTitledBorder("Image"));
        pnlImage.setPreferredSize(new java.awt.Dimension(300, 250));

        javax.swing.GroupLayout pnlImageLayout = new javax.swing.GroupLayout(pnlImage);
        pnlImage.setLayout(pnlImageLayout);
        pnlImageLayout.setHorizontalGroup(
                pnlImageLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(pnlImageLayout.createSequentialGroup()
                                .addComponent(lblImage, javax.swing.GroupLayout.DEFAULT_SIZE, 378, Short.MAX_VALUE)
                                .addContainerGap())
        );
        pnlImageLayout.setVerticalGroup(
                pnlImageLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(pnlImageLayout.createSequentialGroup()
                                .addComponent(lblImage, javax.swing.GroupLayout.DEFAULT_SIZE, 362, Short.MAX_VALUE)
                                .addContainerGap())
        );

        btnSaveImage.setText("Save Image");
        btnSaveImage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveImageActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Variable History"));

        listVariable.setModel(new javax.swing.AbstractListModel() {
            String[] strings = {"Item 1", "Item 2", "Item 3", "Item 4", "Item 5"};

            public int getSize() {
                return strings.length;
            }

            public Object getElementAt(int i) {
                return strings[i];
            }
        });
        jScrollPane2.setViewportView(listVariable);

        txtDescVarValue.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        txtDescVarValue.setColumns(20);
        txtDescVarValue.setEditable(false);
        txtDescVarValue.setRows(5);
        txtDescVarValue.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jScrollPane3.setViewportView(txtDescVarValue);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel1Layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE)
                                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE)
                                        .addComponent(lblDescVarName))
                                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(23, 23, 23)
                                .addComponent(lblDescVarName)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Status"));

        lblToken.setText("ead41af9-c9f6-4615-9a70-f095eac8a974");

        jLabel2.setText("Token      :");

        jLabel3.setText("Broker Host :");

        lblHost.setText("192.168.0.34");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
                jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(lblToken))
                        .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(lblHost))
        );
        jPanel2Layout.setVerticalGroup(
                jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(jLabel2)
                                        .addComponent(lblToken))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(jLabel3)
                                        .addComponent(lblHost)))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Console"));

        txtareaEditor.setColumns(20);
        txtareaEditor.setEditable(false);
        txtareaEditor.setFont(new java.awt.Font("Consolas", 0, 13));
        txtareaEditor.setRows(5);
        jScrollPane1.setViewportView(txtareaEditor);

        txtQuery.setFont(new java.awt.Font("Consolas", 0, 12)); // NOI18N

        btnExe.setText("Execute");
        btnExe.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnExeActionPerformed(evt);
            }
        });

        btnClear.setText("Clear");
        btnClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnClearActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
                jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 426, Short.MAX_VALUE)
                                        .addGroup(jPanel3Layout.createSequentialGroup()
                                                .addComponent(txtQuery, javax.swing.GroupLayout.DEFAULT_SIZE, 286, Short.MAX_VALUE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(btnClear)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(btnExe)))
                                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
                jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 387, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(txtQuery, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(btnExe)
                                        .addComponent(btnClear))
                                .addContainerGap())
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Command History"));

        listCommand.setModel(new javax.swing.AbstractListModel() {
            String[] strings = {"Item 1", "Item 2", "Item 3", "Item 4", "Item 5"};

            public int getSize() {
                return strings.length;
            }

            public Object getElementAt(int i) {
                return strings[i];
            }
        });
        jScrollPane4.setViewportView(listCommand);

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
                jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel4Layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE)
                                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
                jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel4Layout.createSequentialGroup()
                                .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        menuFile.setText("File");

        menuitemExit.setText("Exit");
        menuFile.add(menuitemExit);

        jMenuBar1.add(menuFile);

        menuEdit.setText("Edit");

        menuitemConnectToJMSHost.setText("Connect to Message Broker Host...");
        menuitemConnectToJMSHost.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuitemConnectToJMSHostActionPerformed(evt);
            }
        });
        menuEdit.add(menuitemConnectToJMSHost);

        jMenuBar1.add(menuEdit);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addGap(18, 18, 18)
                                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addComponent(pnlImage, javax.swing.GroupLayout.PREFERRED_SIZE, 400, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(btnSaveImage))
                                .addContainerGap())
        );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(layout.createSequentialGroup()
                                                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(layout.createSequentialGroup()
                                                .addGap(9, 9, 9)
                                                .addComponent(pnlImage, javax.swing.GroupLayout.PREFERRED_SIZE, 400, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(btnSaveImage))
                                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>

    private void formWindowClosed(java.awt.event.WindowEvent evt) {
    }

    private void formWindowClosing(java.awt.event.WindowEvent evt) {

        System.out.println("CLOSING");
        matlabRpc.closeConnection();
    }

    private void btnSaveImageActionPerformed(java.awt.event.ActionEvent evt) {
        // TODO add your handling code here:
        int returnVal = fileChooser.showSaveDialog(MatlabClient.this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fileChooser.getSelectedFile();
            //This is where a real application would save the file.
            if (responseBufferedImage != null) {
                try {
                    ImageIO.write(responseBufferedImage, "png", file);
                } catch (IOException ex) {
                    Logger.getLogger(MatlabClient.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
            System.out.println("Saving: " + file.getName() + ".");
        } else {
            System.out.println("Save command cancelled by user.");
        }
    }

    private void menuitemConnectToJMSHostActionPerformed(java.awt.event.ActionEvent evt) {
        // TODO add your handling code here:

        boolean onConnect = false;
        boolean onTryAgain = true;
        MatlabRPC newMatlabRPC = null;
        while (onTryAgain) {
            String ipAddress = JOptionPane.showInputDialog("Input IP address of Message Broker Host : ");
            try {
                newMatlabRPC = new MatlabRPC(ipAddress);
                onTryAgain = false;
                onConnect = true;
            } catch (IOException ex) {
//                JOptionPane.showMessageDialog(null, "Unable to connect !");
                int choice = JOptionPane.showConfirmDialog(null, "Unable to connect ! Please click 'OK' to input again. ", "Error !", JOptionPane.YES_NO_OPTION);
                if (choice == 0) {
                    onTryAgain = true;
                } else if (choice == 1) {
                    onTryAgain = false;
                    onConnect = false;
                }
            }
        }

        if (onConnect) {
            matlabRpc = newMatlabRPC;
            lblToken.setText(matlabRpc.getToken());
            lblHost.setText(matlabRpc.getHostIp());
        }
    }

    private void btnClearActionPerformed(java.awt.event.ActionEvent evt) {
        // TODO add your handling code here:
        txtQuery.setText("");
    }

    private void btnExeActionPerformed(java.awt.event.ActionEvent evt) {
//        listModel.addElement("tambah");
        lblImage.setIcon(null);
        lblImage.repaint();

        System.out.println("OKE");

        String queryTxt = txtQuery.getText();
        listCommandModel.addElement(queryTxt);

        Variable var = new Variable();
        if (queryTxt.contains("=")) {
            var.setName(queryTxt.split("=")[0]);
            isContainingVariable = true;
        } else {
            isContainingVariable = false;
        }


        if (!"".equals(queryTxt)) {
            txtareaEditor.append(">> " + queryTxt + "\n");

//            String cmdQuery = "query|12345|a=1";
//            String cmdImage = "getimage|12345";
            String cmdQuery = "query|" + matlabRpc.getToken() + "|" + queryTxt;
            String cmdImage = "getimage|" + matlabRpc.getToken();

            String responseQuery = "";
            byte[] responseImage = null;
            try {
                responseQuery = matlabRpc.sendStringMessage(cmdQuery);
                responseImage = matlabRpc.sendByteMessage(cmdImage.getBytes());
            } catch (IOException ex) {
                Logger.getLogger(MatlabClient.class.getName()).log(Level.SEVERE, null, ex);
            } catch (ShutdownSignalException ex) {
                Logger.getLogger(MatlabClient.class.getName()).log(Level.SEVERE, null, ex);
            }

            String result = "";
            if (isContainingVariable) {
                var.setValue(responseQuery);

                if (listVariableModel.contains(var)) {
                    listVariableModel.removeElement(var);
                }
                listVariableModel.addElement(var);

                result += var.getName() + " = \n";
                result += responseQuery;
            } else {
                result += "ans = \n";
                result += responseQuery;

            }

            if (queryTxt.endsWith(";")) {
                result = "";
            }


            System.out.println("RESPON QUERY : " + responseQuery);
            txtareaEditor.append(result + "\n\n");

            System.out.println("RESPON IMAGE : " + responseImage);

            //convert byte array back to BufferedImage
            InputStream in = new ByteArrayInputStream(responseImage);
            responseBufferedImage = null;
            try {
                System.err.println("MASUK TRY");
                responseBufferedImage = ImageIO.read(in);
            } catch (IOException ex) {
                Logger.getLogger(MatlabClient.class.getName()).log(Level.SEVERE, null, ex);
            }

            if (responseBufferedImage != null) {
                lblImage.setIcon(new ImageIcon(responseBufferedImage));
                lblImage.repaint();
            }

        }
    }
    // End of variables declaration                   
}
