/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.fahri.matlab.client;

import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;
import com.rabbitmq.client.RpcClient;

import java.io.IOException;
import java.util.concurrent.TimeoutException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * @author admin
 */
public class MatlabRPC {

    private final static String TOKEN = java.util.UUID.randomUUID().toString();
    private String HOST_IP;
    private Connection connection;
    private Channel channel;
    private RpcClient service;
    private ConnectionFactory cfconn;

    public MatlabRPC(String host) throws IOException {
        this.HOST_IP = host;

        cfconn = new ConnectionFactory();
        cfconn.setHost(HOST_IP);

        connection = cfconn.newConnection();
        channel = connection.createChannel();
        service = new RpcClient(channel, "", "MATLAB");
    }

    public String sendStringMessage(String message) throws IOException {
        try {
            return service.stringCall(message);
        } catch (TimeoutException e) {
            e.printStackTrace();
        }
        return null;
    }

    public byte[] sendByteMessage(byte[] message) throws IOException {
        try {
            return service.primitiveCall(message);
        } catch (TimeoutException e) {
            e.printStackTrace();
        }
        return null;
    }

    public boolean connectTo(String host) {
        try {
            cfconn.setHost(host);
            connection = cfconn.newConnection();
            channel = connection.createChannel();
            service = new RpcClient(channel, "", "MATLAB");
            return true;
        } catch (IOException ex) {
            return false;
        }
    }

    public String getHostIp() {
        return HOST_IP;
    }

    public String getToken() {
        return TOKEN;
    }

    public void closeConnection() {
        try {
            connection.close();
        } catch (IOException ex) {
            Logger.getLogger(MatlabRPC.class.getName()).log(Level.SEVERE, null, ex);
        }
    }


}
